var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as classnames from "classnames";
import * as React from "react";
import * as PropTypes from "prop-types";
import "./Tab.less";
export var cssClass = {
    CONTAINER: "TabBar--Tab",
    DISABLED: "TabBar--Tab--disabled",
    SELECTED: "TabBar--Tab--selected",
};
export default function Tab(_a) {
    var children = _a.children, className = _a.className, component = _a.component, disabled = _a.disabled, href = _a.href, id = _a.id, onSelect = _a.onSelect, selected = _a.selected, tabContentID = _a.tabContentID, additionalProps = __rest(_a, ["children", "className", "component", "disabled", "href", "id", "onSelect", "selected", "tabContentID"]);
    var Wrapper = component;
    if (!Wrapper) {
        Wrapper = href ? "a" : "button";
    }
    return (React.createElement(Wrapper, __assign({ className: classnames(cssClass.CONTAINER, disabled && cssClass.DISABLED, selected && cssClass.SELECTED, className), disabled: disabled, href: href, onClick: function (e) {
            if (disabled) {
                e.preventDefault();
                return;
            }
            onSelect(id);
        }, role: "tab", "aria-selected": selected, "aria-controls": tabContentID }, additionalProps), children));
}
Tab.propTypes = {
    children: PropTypes.node.isRequired,
    className: PropTypes.string,
    component: PropTypes.any,
    disabled: PropTypes.bool,
    href: PropTypes.string,
    id: PropTypes.any.isRequired,
    onSelect: PropTypes.func,
    selected: PropTypes.bool,
};
Tab.defaultProps = {
    onSelect: function () { },
};
